//
//	(c) Paul Campbell 2012 - released under LGPL
//	This file is part of the DSPace Robot support software.
//
//	The DSPace Robot support software is free software: you can
// 	redistribute it and/or modify it under the terms of the
//	Lesser GNU General Public License as published by the Free
//	Software Foundation, either version 3 of the License, or
//	(at your option) any later version.
//
//	The DSPace Robot support software is distributed in the hope
//	that it will be useful, but WITHOUT ANY WARRANTY; without even
//	the implied warranty of MERCHANTABILITY or FITNESS FOR A
//	PARTICULAR PURPOSE.  See the Lesser GNU General Public License
//	for more details.
//
//	You should have received a copy of the lesser GNU General Public
//	License along with the DSPace Robot support software.  If not,
//	see <http://www.gnu.org/licenses/>.
//
#include "line_follower.h"


void
LineFollowerRobotSensor::SetThreshold(int r1, int g1, int b1, int r2, int g2, int b2 )
{
	unsigned char x[6];
	x[0] = r1;
	x[1] = g1;
	x[2] = b1;
	x[3] = r2;
	x[4] = g2;
	x[5] = b2;
	WriteArray(ADDRESS, &x[0], 6);
}

int 
LineFollowerRobotSensor::Read0() 
{ 
  unsigned char x[1]; 

  WriteAddress(ADDRESS, READ_0);
  ReadArray(ADDRESS, &x[0], 1); 
  return x[0]; 
}

int 
LineFollowerRobotSensor::Read1()
{

  unsigned char x[1];

  WriteAddress(ADDRESS, READ_1);
  ReadArray(ADDRESS,  &x[0], 1);
  return x[0];
}

void
LineFollowerRobotSensor::ReadThreshold(int &r1, int &g1, int &b1, int &r2, int &g2, int &b2)
{
  unsigned char x[2];

  WriteAddress(ADDRESS, READ_THRESHOLD);
  ReadArray(ADDRESS,  &x[0], 2);
  b1 = (x[0]&0x01?0:x[1]&0x01?2:1);
  b2 = (x[0]&0x02?0:x[1]&0x02?2:1);
  g1 = (x[0]&0x04?0:x[1]&0x04?2:1);
  g2 = (x[0]&0x08?0:x[1]&0x08?2:1);
  r1 = (x[0]&0x10?0:x[1]&0x10?2:1);
  r2 = (x[0]&0x20?0:x[1]&0x20?2:1);
}

void 
LineFollowerRobotSensor::Read01(int &v1, int &v2) 
{
  unsigned char x[4]; 

  WriteAddress(ADDRESS, READ_01);
  ReadArray(ADDRESS, &x[0], 2);
  v1 = x[0];
  v2 = x[1]; 
}
